﻿using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Web.Mvc;
using System.Xml.Linq;

namespace MvcApplication1.Controllers {
    public class TwitterController : Controller {
        public ActionResult Index() {
            var request = WebRequest.Create("http://search.twitter.com/search.atom?q=qixotic&rpp=25") as HttpWebRequest;
            var twitterViewData = new List<TwitterViewData>();

            if (request != null) {
                using (var response = request.GetResponse() as HttpWebResponse) {
                    if (response != null) {
                        var responseStream = response.GetResponseStream();
                        if (responseStream != null) {
                            var streamReader = new StreamReader(responseStream);
                            using (var reader = streamReader) {
                                var document = XDocument.Parse(reader.ReadToEnd());
                                XNamespace xmlns = "http://www.w3.org/2005/Atom";

                                twitterViewData = (document.Descendants(xmlns + "entry").Select(
                                    entry => new TwitterViewData {
                                        Content = entry.Element(xmlns + "content").Value,
                                        Updated = entry.Element(xmlns + "updated").Value,
                                        AuthorName =
                                                 entry.Element(xmlns + "author").Element(xmlns + "name").Value,
                                        AuthorUri = entry.Element(xmlns + "author").Element(xmlns + "uri").Value,
                                        Link = (entry.Descendants(xmlns + "link").Where(
                                            o => o.Attribute("rel").Value == "image").Select(
                                                o => new {Val = o.Attribute("href").Value})).First().Val
                                    })).ToList();
                            }
                        }
                    }
                }
            }
            return View(twitterViewData);
        }
    }
}